#
# This file is part of pySMT.
#
#   Copyright 2014 Andrea Micheli and Marco Gario
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#
if __name__ == "__main__":
    import timeit

    creation_exec_time = timeit.timeit(
                            "build_random_formula(15, 12, 6, 0.1, seed=42)",
                            "from pysmt.randomizer import build_random_formula",
                            number = 50000)

    serialization_exec_time = timeit.timeit(
                            "str(build_random_formula(15, 12, 6, 0.1, seed=42))",
                            "from pysmt.randomizer import build_random_formula",
                            number = 50000)

    serialization_exec_time = (serialization_exec_time-creation_exec_time)

    print("Formula creation: " + str(creation_exec_time))
    print("Formula serialization: " + str(serialization_exec_time))
